<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema"
    xmlns:math="http://www.w3.org/2005/xpath-functions/math"
    xmlns:map="http://www.w3.org/2005/xpath-functions/map"
    xmlns:doc="http://www.saxonica.com/ns/doc" xmlns:f="MyFunctions"
    xmlns:svg="http://www.w3.org/2000/svg" xmlns:saxon="http://saxon.sf.net/"
    exclude-result-prefixes="xs math f doc" version="3.0">

    <doc:synopsis title="Template call display">
        <p>Generate a set of displays for template calls</p>
    </doc:synopsis>

    <!-- *IMPORTANT* This needs the '-l' option on Saxon to track source line numbers -->
    <xsl:mode name="stats.call.svg" on-no-match="shallow-skip"/>
    <xsl:template match="group[tokenize(@show, '\s+') = 'call']" mode="stats.call.svg">
        <xsl:apply-templates select="." mode="stats.barchart.svg">
            <xsl:with-param name="name" tunnel="yes">calls</xsl:with-param>
            <xsl:with-param name="data.format"  tunnel="yes" as="function(*)"
                select="
                function ($a) {
                format-number($a, ',##0')
                }"
                doc:doc="Integral number of calls"/>
            <xsl:with-param name="valueOfInterest" as="function(*)"
                select="
                function ($c) {
                $c/@invocations
                }"
                tunnel="yes"/>
            <xsl:with-param name="options" as="map(*)" tunnel="yes"
                select="map{
                'axis.x.format' : function($a) {format-number($a idiv 1,'0')} ,
                'axis.x.label' : '# calls',
                'label' : 'Template pattern matches'}"
            />
        </xsl:apply-templates>
    </xsl:template>
    <xsl:mode name="stats.call" on-no-match="shallow-copy"/>
    <xsl:template match="group[tokenize(@show, '\s+') = 'call']" mode="stats.call">
        <xsl:apply-templates select="." mode="stats.barchart">
            <xsl:with-param name="name" tunnel="yes">calls</xsl:with-param>
            <xsl:with-param name="valueOfInterest" as="function(*)"
                select="
                function ($c) {
                $c/@invocations
                }"
                tunnel="yes"/>
            <xsl:with-param name="options" as="map(*)" tunnel="yes"
                select="map{
                'axis.x.format' : function($a) {format-number($a idiv 1,'0')} ,
                'axis.x.label' : '# calls',
                'label' : 'Template pattern matches'}"
            />
        </xsl:apply-templates>
    </xsl:template>

</xsl:stylesheet>
